---
title: SourceBuffer.remove()
slug: Web/API/SourceBuffer/remove
tags:
  - API
  - Audio
  - Experimental
  - MSE
  - Media Source Extensions
  - Method
  - Reference
  - SourceBuffer
  - Video
  - remove
---
<div>{{draft}}{{APIRef("Media Source Extensions")}}{{SeeCompatTable}}</div>

<p>The <code><strong>remove()</strong></code> method of the {{domxref("SourceBuffer")}} interface removes media segments within a specific time range from the <code>SourceBuffer</code>. This method can only be called when {{domxref("SourceBuffer.updating")}} equals <code>false</code>. If <code>SourceBuffer.updating</code> is not equal to <code>false</code>, call {{domxref("SourceBuffer.abort()")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>sourceBuffer</em>.remove(<em>start</em>, <em>end</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>start</dt>
 <dd>A double representing the start of the time range, in seconds.</dd>
 <dt>end</dt>
 <dd>A double representing the end of the time range, in seconds.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{jsxref('undefined')}}.</p>

<h3 id="Exceptions">Exceptions</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Explanation</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>InvalidAccessError</code></td>
   <td>The {{domxref("MediaSource.duration")}} property is equal to <code>NaN</code>, the <code>start</code> parameter is negative or greater than {{domxref("MediaSource.duration")}}, or the end parameter is less than or equal to start or equal to <code>NaN</code>.</td>
  </tr>
  <tr>
   <td><code>InvalidStateError</code></td>
   <td>The {{domxref("SourceBuffer.updating")}} property is equal to <code>true</code>, or this <code>SourceBuffer</code> has been removed from the {{domxref("MediaSource")}}.</td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>TBD.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Source Extensions', '#dom-sourcebuffer-remove', 'remove()')}}</td>
   <td>{{Spec2('Media Source Extensions')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.SourceBuffer.remove")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("MediaSource")}}</li>
 <li>{{domxref("SourceBufferList")}}</li>
</ul>
